/*    $  *  ४ᨢ ॡ */
#include <stdio.h>
#include <string.h>
char map[102][102];
typedef struct _coord { char i,j; } coord;
coord q[50*50];
int step[50][50];
int stepout;
int q1,q2,koldol;
int n=0,m;
coord dol[7];
int dist[7][7];
void move(int p, int i, int j, int di, int dj)
{ int ch;
  if(di==1 && map[i+di][j+dj]!='v') return;
  if(di==-1 && map[i+di][j+dj]!='^') return;
  if(dj==1 && map[i+di][j+dj]!='>') return;
  if(dj==-1 && map[i+di][j+dj]!='<') return;
  if(i+di*2<0 || i+di*2>=n || j+dj*2<0 || j+dj*2>=m)
  {
    if(stepout<0)
    {
      stepout=step[i/2][j/2]+1;
      dist[p][6]=stepout;
    }
  }
  else
  {
    if(step[i/2+di][j/2+dj]<0)
    {
      step[i/2+di][j/2+dj]=step[i/2][j/2]+1;
      q[q2].i=i+di*2;
      q[q2].j=j+dj*2;
      ++q2;
      ch=map[i+di*2][j+dj*2];
      if(ch>='0' && ch<='9')
        dist[p][ch-'0']=step[i/2][j/2]+1;
    }
  }
}
void wave(int p, int i0, int j0)
{ int i,j;
  for(i=0;i<n/2;++i)
    for(j=0;j<m/2;++j)
      step[i][j]=-1;
  stepout=-1;
  q1=0;
  q[0].i=i0;
  q[0].j=j0;
  step[i0/2][j0/2]=0;
  q2=1;
  while(q1<q2)
  {
    i=q[q1].i;
    j=q[q1].j;
    ++q1;
    move(p,i,j,1,0);
    move(p,i,j,-1,0);
    move(p,i,j,0,1);
    move(p,i,j,0,-1);
  }
}
int sobr=-1,door=0;
int used[7];
void rec(int last, int sr, int dr)
{ int i;
  if(dist[last][6]<0) return;
  if(sr>sobr || sr==sobr && dr+dist[last][6]<door)
  {
    sobr=sr;
    door=dr+dist[last][6];
  }
  for(i=1;i<=koldol;++i)
  { if(!used[i] && dist[last][i]>0)
    {
      used[i]=1;
      rec(i,sr+1,dr+dist[last][i]);
      used[i]=0;
    }      
  }
}
int main()
{  int i,j;
   freopen("input.txt","r",stdin);
   freopen("output.txt","w",stdout);
   while(scanf("%s",map[n])==1)
     n++;
   m=strlen(map[0]);
   koldol=0;
   for(i=0;i<n;++i)
     for(j=0;j<m;++j)
       if(map[i][j]=='$')
       { ++koldol;
         if(koldol>5) 
         { printf("Error\n");
           return 1;
         }
         map[i][j]='0'+koldol;
         dol[koldol].i=i;
         dol[koldol].j=j;
       }
       else if(map[i][j]=='*')
       {
         map[i][j]='0';
         dol[0].i=i;
         dol[0].j=j;
       }
   for(i=0;i<7;++i)
     for(j=0;j<7;++j)
        dist[i][j]=-1;
   for(i=0;i<7;++i)
   { wave(i,dol[i].i,dol[i].j);
     used[i]=0;
   }
   used[0]=1;
   rec(0,0,0);
   if(sobr<0)
     printf("-1\n");
   else
     printf("%d %d\n",sobr,door);
   return 0;
}
