#include <stdio.h>
#include <string.h>
char line[128];
int nline=0;
int nwar=0;
int getline(void)
{ ++nline;
  return fgets(line,110,stdin)!=NULL;
}
long scan(char *s)
{ long u=0;
  if(s==NULL) return 0;
  while(*s)
  { if(*s>='A' && *s<='Z')
      u|=1L<<(*s-'A');
    ++s;
  }
  return u;
}
void war1(void)
{
  printf("Line %d: unreachable code\n",nline);
  ++nwar;
}
void war2(long na)
{ int i;
  for(i=0;i<26;++i)
    if(na&(1L<<i))
    {
      printf("Line %d: variable %c might not have been initialized\n",nline,i+'A');
      ++nwar;
    }
}
long go(long *a, int *flg)
{
  long u=0,t1,e1,z;
  int e2,t2;
  while(1)
  {
    if(line[0]=='E' && (line[1]=='N' || line[1]=='L') || 
       line[0]=='W' && line[1]=='E')
      return u;
    if(line[0]=='R' && line[1]=='E')
    { 
      if(!*flg) war1();
      *flg=0;
      getline();
    }
    else if(line[0]=='I' && line[1]=='F')
    {
      line[strlen(line)-5]=0;
      if(*flg)
      { u|=(z=scan(line+2));
        war2(z&~*a);
      }
      else war1();
      getline();
      e1=t1=*a;
      e2=t2=*flg;
      u|=go(&t1,&t2);
      if(line[0]=='E' && line[1]=='L')
      { getline();
        u|=go(&e1,&e2);
      }
      getline();
      *a=t1&e1;
      *flg=t2||e2;
    }
    else if(line[0]=='W' && line[1]=='H')
    { 
      line[strlen(line)-3]=0;
      if(*flg)
      { u|=(z=scan(line+5));
        war2(z&~*a);
      }
      else war1();
      getline();
      t1=*a;
      t2=*flg;
      u|=go(&t1,&t2);
      getline();
    }
    else
    {
      if(*flg)
      { u|=(z=scan(line+2));
        war2(z&~*a);
        u|=(z=1L<<(line[0]-'A'));
        *a|=z;
      }
      else war1();
      getline();
    }
  }
}
int main()
{
   long p,a,u;
   int i,flg;
   freopen("input.txt","r",stdin);
   freopen("output.txt","w",stdout);
   while(getline())
   { p=a=scan(strchr(line,'('));
     getline();
     flg=1;
     u=go(&a,&flg);
     for(i=0;i<26;++i)
       if((p&~u)&(1L<<i))
       {
         printf("Line %d: parameter %c is never used\n",nline,i+'A');
         ++nwar;
       }
   }
   if(nwar==0)
     printf("No warnings\n");
   return 0;
}
